<template>
	<div :class="[imageStyle, sizeClass]" class="flex justify-center">
		<img v-if="mockProductImg" class="max-h-full" :src="mockProductImg" :alt="productName" />
		<img v-if="isClyde" alt="Clyde logo" class="mr-2 w-6 h-6" src="~/assets/images/clyde.svg" />
		<img v-if="slugImg" class="max-h-full" :src="slugImg" :alt="productName || productDetail.productName" />
	</div>
</template>
<script>
export default {
	name: 'MkProductImage',
	components: {},
	props: {
		imageStyle: {
			type: String,
			default: '',
		},
		productDetail: {
			type: Object,
			default: () => {},
		},
		mockProductImg: {
			type: String,
			default: '',
		},
		productName: {
			type: String,
			default: '',
		},
		productSku: {
			type: String,
			default: '',
		},
		isClyde: {
			type: Boolean,
			default: false,
		},
		sizeClass: {
			type: String,
			default: '',
		},
	},
	data() {
		return {
			productImg: '',
			slugImg: '',
		};
	},
	watch: {
		productDetail() {
			this.getImage();
		},
	},
	mounted() {
		this.getImage();
	},
	methods: {
		async getImage() {
			if (
				!this.slugImg &&
				(this.productSku ||
					this.productDetail.sku ||
					this.productDetail.productSku ||
					(this.productDetail && this.productDetail.variant && this.productDetail.variant.sku))
			) {
				this.slugImg = await this.$root.$getImage(
					this.productSku ||
						this.productDetail.sku ||
						this.productDetail.productSku ||
						(this.productDetail.variant && this.productDetail.variant.sku)
				);
			}
		},
	},
};
</script>
